#!/usr/bin/env python

__version__ = '$Revision: 4799 $'.split()[1]
__date__ = '$Date: 2006-09-25 11:09:02 -0400 (Mon, 25 Sep 2006) $'.split()[1]
__author__ = 'John Doe FIX: put in the authors name'

__doc__='''

Example python file that is all tricked out.  Designed for epydoc,
unittest and doctest.  Please keep updating to make this the best
possible template file.

@requires: U{lxml<http://codespeak.net/lxml/>} - For libxml2 ElementTree interface.  Not actually required for the template, but this is just a demo or requirements.
@requires: U{Python<http://python.org/>} >= 2.4
@requires: U{epydoc<http://epydoc.sourceforge.net/>} >= 3.0alpha3

@author: U{'''+__author__+'''<http://xenon.stanford.edu/~schwehr/>} FIX: replace with your name/url
@version: ''' + __version__ +'''
@copyright: 2006
@var __date__: Date of last svn commit
@undocumented: __version__ __author__ __doc__ myparser
@since: 2006-Sep-26  FIX: replace with the file creation date
@status: under development
@organization: U{CCOM<http://ccom.unh.edu/>} - FIX: if not CCOM change the name and link

@license: CCOM internal use only, unless explicitly authorized.  If
this is just the template, then no license is implied.

@bug: epydoc --check complains about unittest additions
@bug: Bug two
@todo: Keep writing example code
@todo: copy the code and replace the author and since fields
@todo: To make your code executable after check-in (to allow for doc and unittest), do svn propset svn:executable ON yourfile.py
@todo: "svn propedit svn:keywords yourfile.py", then put in "Date Revision"

@see: U{python idioms<http://jaynes.colorado.edu/PythonIdioms.html>} - Read this before modifying any code here.

'''

import sys
#import time
#import datetime


######################################################################
class Template:
    '''
    Class documentation goes here.

    >>> print 'This is a doctest'
    This is a doctest
    '''
    def __init__(self,someArg=None):
	'''
	Initialize the class.  Add some detail here.

	@param someArg: example argument
	'''
	pass  # A way to have a do nothing stub

    def aMethod(self,anotherArg):
	'''
	This is a really dumb method that prints it's arg.

	This is the detailed description of aMethod that tells you it
	is a really moronic method.  It does howver show how to
	document a class method.

	And a doctest on how to use this exciting method

	>>> Template().aMethod('hello world')
	hello world

	@param anotherArg: what to print
	@return: prints the arg to stdout.
	'''
	print anotherArg

    def aDoNothingMethod(self):
	'''
	How to write a stub that does not do anything
	'''
	pass

######################################################################
# UNIT TESTING
######################################################################
import unittest

class TestTemplate(unittest.TestCase):
    '''Unit testing of the Template class.  
    Make lots of testFoo methods to exercise the class.
    '''
    def testSomething(self):
	'''Can have many test methods like this.  The name must start with test.
	'''
	t = Template()
	t.aDoNothingMethod()
	# FIX: assert some stuff about template
	self.failUnless(1==1)


######################################################################
# Code that runs when this is this file is executed directly
######################################################################
if __name__ == '__main__':
    from optparse import OptionParser
    parser = OptionParser(usage="%prog [options]"
                          ,version="%prog "+__version__+' ('+__date__+')')
    parser.add_option('--doc-test',dest='doctest',default=False,action='store_true'
                      ,help='run the documentation tests')
    parser.add_option('--unit-test',dest='unittest',default=False,action='store_true'
                      ,help='run the unit tests')
    parser.add_option('-v','--verbose',dest='verbose',default=False,action='store_true'
                      ,help='run the tests run in verbose mode')

    (options,args) = parser.parse_args()

    success=True

    if options.doctest:
	import os; print os.path.basename(sys.argv[0]), 'doctests ...',
	argvOrig = sys.argv
	sys.argv= [sys.argv[0]]
	if options.verbose: sys.argv.append('-v')
	import doctest
	numfail,numtests=doctest.testmod()
	if numfail==0: print 'ok'
	else: 
	    print 'FAILED'
	    success=False
	sys.argv = argvOrig # Restore the original args
	del argvOrig # hide from epydoc

    if not success:
	sys.exit('Something Failed')

    del success # Hide success from epydoc

    if options.unittest:
	sys.argv = [sys.argv[0]]
	if options.verbose: sys.argv.append('-v')
	unittest.main()
	# Never reaches here

